/*
 * Created on 2004. 2. 19.
 *
 */
package net.narusas.daap.server.response;


import net.narusas.daap.server.*;
import net.narusas.daap.server.api.*;
import net.narusas.daap.server.tag.*;

/**
 * @author Jisung, Ahn
 *
 */
public class ContentCodeResponse implements DaapResponse {
	
	String[] metas = new String[] {
			"dmap.itemid",
			"dmap.itemname",
			"dmap.itemkind",
			"dmap.persistentid",
			"dmap.container",
			"dmap.containeritemid",
			"dmap.parentcontainerid",
			"dmap.status",
			"dmap.statusstring",
			"dmap.itemcount",
			"dmap.containercount",
			"dmap.returnedcount",
			"dmap.specifiedtotalcount",
			"dmap.listing",
			"dmap.listingitem",
			"dmap.bag",
			"dmap.dictionary",
			"dmap.serverinforesponse",
			"dmap.authenticationmethod",
			"dmap.loginrequired",
			"dmap.protocolversion",
			"dmap.supportsautologout",
			"dmap.supportsupdate",
			"dmap.supportspersistentids",
			"dmap.supportsextensions",
			"dmap.supportsbrowse",
			"dmap.supportsquery",
			"dmap.supportsindex",
			"dmap.supportsresolve",
			"dmap.timeoutinterval",
			"dmap.databasescount",
			"dmap.loginresponse",
			"dmap.sessionid",
			"dmap.updateresponse",
			"dmap.serverrevision",
			"dmap.updatetype",
			"dmap.deletedidlisting",
			"dmap.contentcodesresponse",
			"dmap.contentcodesnumber",
			"dmap.contentcodesname",
			"dmap.contentcodestype",
			"daap.protocolversion",
			"daap.serverdatabases",
			"daap.databasebrowse",
			"daap.browsealbumlisting",
			"daap.browseartistlisting",
			"daap.browsecomposerlisting",
			"daap.browsegenrelisting",
			"daap.databasesongs",
			"daap.songalbum",
			"daap.songgrouping",
			"daap.songartist",
			"daap.songbeatsperminute",
			"daap.songbitrate",
			"daap.songcomment",
			"daap.songcompilation",
			"daap.songcomposer",
			"daap.songdateadded",
			"daap.songdatemodified",
			"daap.songdisccount",
			"daap.songdiscnumber",
			"daap.songdisabled",
			"daap.songeqpreset",
			"daap.songformat",
			"daap.songgenre",
			"daap.songdescription",
			"daap.songrelativevolume",
			"daap.songsamplerate",
			"daap.songsize",
			"daap.songstarttime",
			"daap.songstoptime",
			"daap.songtime",
			"daap.songtrackcount",
			"daap.songtracknumber",
			"daap.songuserrating",
			"daap.songyear",
			"daap.songdatakind",
			"daap.songdataurl",
			"daap.databaseplaylists",
			"daap.baseplaylist",
			"daap.playlistsongs",
			"daap.resolve",
			"daap.resolveinfo",
			"com.apple.itunes.norm-volume",
			"com.apple.itunes.smart-playlist"
	};
	
	int[] metaCode = new int[] {
			1835624804,
			1835626093,
			1835625316,
			1836082546,
			1835233134,
			1835234409,
			1836082031,
			1836282996,
			1836282995,
			1835625827,
			1835234403,
			1836213103,
			1836344175,
			1835819884,
			1835821428,
			1835164524,
			1835295596,
			1836282486,
			1836278133,
			1836280946,
			1836085871,
			1836278124,
			1836283248,
			1836281961,
			1836279160,
			1836278386,
			1836282233,
			1836280184,
			1836282483,
			1836282989,
			1836278883,
			1835822951,
			1835821412,
			1836413028,
			1836413810,
			1836414073,
			1836409964,
			1835230066,
			1835232877,
			1835232865,
			1835234425,
			1634759279,
			1635148898,
			1633841775,
			1633837420,
			1633837426,
			1633837936,
			1633838958,
			1633968755,
			1634951532,
			1634169456,
			1634951538,
			1634951796,
			1634951794,
			1634952045,
			1634952047,
			1634952048,
			1634952289,
			1634952301,
			1634952291,
			1634952302,
			1634952290,
			1634952561,
			1634952813,
			1634953070,
			1634952308,
			1634955894,
			1634956146,
			1634956154,
			1634956148,
			1634956144,
			1634956397,
			1634956387,
			1634956398,
			1634956658,
			1634957682,
			1634952299,
			1634956652,
			1634757753,
			1633841260,
			1634759535,
			1634890614,
			1634888038,
			1634029142,
			1634030416
	};
	ListTag mccr;
	/**
	 * @param req
	 * @param _db
	 */
	public ContentCodeResponse(DaapRequest req, Database _db) {
		mccr = Tag.listTag("mccr");
		mccr.addTag(Tag.integerTag("mstt",200));
		for(int i=0 ; i < metas.length;i++){
			ListTag mdcl = Tag.listTag("mdcl");
			mccr.addTag(mdcl);
			mdcl.addTag(Tag.integerTag("mcnm",metaCode[i]));
			mdcl.addTag(Tag.stringTag("mcna",metas[i]));
		}
		 
	}

	public ListTag getResponse(){
		return mccr;
	}
}
