import java.util.*;

/*
 * Created on 2004. 2. 25.
 *  
 */
/**
 * @author Jisung, Ahn
 *  
 */
public class SortedShifts {

	private int _count;
	private ArrayList _shifts = new ArrayList();

	public SortedShifts(String input) {
		String[] lines = splitWords(input,"\n");
		
		for(int i=0; i < lines.length;i++) {			
			shiftLine(lines[i]);
		}		
		Collections.sort(_shifts);
	}

	/**
	 * @param words
	 */
	private void shiftLine(String line) {
		String[] words = splitWords(line);
		for(int j=0; j < words.length ; j++) {
			_shifts.add(concatWords(words));
			words = shiftWords(words);
		}
	}

	private String[] subArray(String[] shift, int i) {
		String[] temp = new String[shift.length-i];
		System.arraycopy(shift,i,temp,0,shift.length-i);
		return temp;
	}
	
	private String[] concatArray(String[] head, String[] tail) {
		String[] temp = new String[head.length + tail.length];
		int count = 0;
		for (int i = 0; i < head.length; i++) {
			temp[count++] = head[i];
		}
		for (int i = 0; i < tail.length; i++) {
			temp[count++] = tail[i];
		}
		return temp;
	}
	static String[] splitWords(String input) {
		return splitWords(input, " ");
		
	}
	
	static String[] splitWords(String input, String filter) {		
		StringTokenizer tokens = new StringTokenizer(input, filter);
		int count = tokens.countTokens();
		String[] result = new String[count];
		for (int i = 0; i < count; i++) {
			result[i] = tokens.nextToken();
		}
		return result;
	}
	
	private String[] shiftWords(String[] words) {	
		return concatArray(subArray(words,1), new String[]{words[0]});		
	}
	
	public String concatWords(String[] src) {
		StringBuffer buf = new StringBuffer();
		for (int i = 0; i < src.length; i++) {
			buf.append(src[i]);
			if (i + 1 < src.length) {
				buf.append(' ');
			}
		}
		return buf.toString();
	}
	
	public String nextShift() {
		return hasNext() ? (String) _shifts.get(_count++) : null;
	}

	/**
	 * @return
	 */
	public boolean hasNext() {		
		return _count < _shifts.size();
	}
}
