/*
 * Created on 2004. 3. 3
 *
 */
package net.narusas.facet;

import java.util.*;

/**
 * @author jsahn
 *
 */
public class Facet extends Observable {

	private String _name;

	private HashMap _topics = new HashMap();

	private String _id;

	private static HashSet ID_SET = new HashSet();
	private static long NEXT_ID;
	protected static final Facet NAME_FACET = new Facet("Name","Name");

	/**
	 * @param string
	 */
	public Facet(String name) {
		this(Facet.nextId(), name);
	}

	public Facet(String id, String name) {
		_name = name;
		if (Facet.existID(id)) {
			_id = Facet.nextId();
		} else {
			_id = id;
		}
	}

	/**
		 * @param id
		 * @return
		 */
	private static boolean existID(String id) {
		return ID_SET.contains(id);
	}

	/**
	 * 
	 */
	private synchronized static String nextId() {
		String nextId = null;
		while (true) {
			nextId = String.valueOf(NEXT_ID++);
			if (!Facet.existID(nextId)) {
				break;
			}
		}
		return nextId;
	}

	/**
	 * 
	 */
	public String getId() {
		return _id;
	}

	public String getName() {
		return _name;
	}

	/**
	 * @param string
	 * @return
	 */
	public Topic createTopic(String name) {
		if (_topics.containsKey(name)) {
			return (Topic) _topics.get(name);
		}
		Topic topic = new Topic(name, this);
		_topics.put(name, topic);
		notifyObservers();
		return topic;
	}

	/**
	 * @param string
	 * @return
	 */
	public Topic getTopic(String name) {
		return (Topic) _topics.get(name);
	}

	/**
	 * 
	 */
	public Topic[] getRootTopic() {
		Topic[] allChilds = (Topic[]) _topics.values().toArray(new Topic[0]);
		ArrayList result = new ArrayList(allChilds.length);
		for (int i = 0; i < allChilds.length; i++) {
			if (allChilds[i].getParent() == null) {
				result.add(allChilds[i]);
			}
		}
		return result.size() == 0
			? null
			: (Topic[]) result.toArray(new Topic[0]);
	}

	public String toString() {
		return _name;
	}
}
