/*
 * Created on 2004. 3. 3
 *
 */
package net.narusas.facet;

import java.util.HashMap;
import java.util.Map;
import java.util.Observable;

/**
 * @author jsahn
 *
 */
public class FacetClassifier extends Observable {

	private String _name;
	private Map _resources = new HashMap();
	private Map _facets = new HashMap();
	/**
	 * @param string
	 */
	public FacetClassifier(String name) {
		_name = name;
	}

	/**
	 * @param res
	 */
	public void addResource(Resource res) {
		_resources.put(res.getId(), res);
		this.notifyObservers(res);
	}

	/**
	 * 
	 */
	public Resource[] getAllResources() {
		return _resources.size() == 0
			? null
			: (Resource[]) _resources.values().toArray(new Resource[0]);
	}

	/**
	 * @param facet
	 */
	public void addFacet(Facet facet) {
		_facets.put(facet.getId(), facet);
		this.notifyObservers(facet);
	}
	
	public Facet getFacet(String id){
		return (Facet) _facets.get(id);
	}

	/**
	 * 
	 */
	public Facet[] getFacets() {
		return _facets.size() == 0
			? null
			: (Facet[]) _facets.values().toArray(new Facet[0]);

	}

	/**
	 * @param topics
	 * @return
	 */
	public Resource[] match(Topic[] topics) {
		if (topics == null) {
			return null;
		}
		ResourceMatch matcher = new ResourceMatch(getAllResources());
		for (int i = 0; i < topics.length; i++) {
			matcher.addCondition(topics[i]);
		}
		return matcher.match();
	}
}
