/*
 * ۼ ¥: 2004. 3. 4.
 *
 */
package net.narusas.facet.ui;

import java.awt.Dimension;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JFrame;
import javax.swing.JPanel;

import net.narusas.facet.Facet;
import net.narusas.facet.FacetClassifier;
import net.narusas.facet.Topic;

/**
 * @author Administrator
 *
 */
public class FacetCollectionPanel extends JPanel {

	private Map _selectedTopics = new HashMap();
	private LinkedList _facets;
	private FacetClassifier _classifier;
	private javax.swing.JScrollPane jScrollPane = null;
	private javax.swing.JPanel displayPanel = null;
	/**
	 * This is the default constructor
	 */
	public FacetCollectionPanel() {
		super();
		_facets = new LinkedList();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new java.awt.BorderLayout());
		this.add(getJScrollPane(), java.awt.BorderLayout.CENTER);
		this.setSize(425, 252);
	}
	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new javax.swing.JScrollPane();
			jScrollPane.setViewportView(getDisplayPanel());
		}
		return jScrollPane;
	}
	/**
	 * This method initializes displayPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getDisplayPanel() {
		if (displayPanel == null) {
			displayPanel = new javax.swing.JPanel();
			displayPanel.setLayout(new HorizontalLayout());
		}
		return displayPanel;
	}

	public void setFacetClassifier(FacetClassifier classifier) {
		_classifier = classifier;
		_classifier.addObserver(new Observer() {
			public void update(Observable o, Object obj) {
//				if (obj instanceof Facet) {
					updateFacet();
//				}

			}
		});
		updateFacet();
	}

	void updateFacet() {
		JPanel p = getDisplayPanel();
		p.removeAll();
		_selectedTopics.clear();
		_facets.clear();
		Facet[] facets = _classifier.getFacets();
		if (facets == null) {
			return;
		}
		for (int i = 0; i < facets.length; i++) {
			FacetTree tree = new FacetTree();
			tree.setFacet(facets[i]);
			tree.setPreferredSize(new Dimension(150, 100));
			tree.addPropertyChangeListener(
				"SelectedTopic",
				new PropertyChangeListener() {
					public void propertyChange(PropertyChangeEvent evt) {
						topicChanged();
					}
				}
			);
			_facets.add(tree);
			p.add(tree, null);
		}
		this.updateUI();
	}

	/**
	 * @param name
	 * @param topic
	 */
	protected void topicChanged() {

		_selectedTopics.clear();
		for(int i=0; i < _facets.size();i++){
			FacetTree tree = (FacetTree) _facets.get(i);
			Topic t = tree.getSelectedTopic();
			if ( t == null) {
				continue;
			}
			
			_selectedTopics.put(t.getName(),t);
			 
			
		}
		notifySelectedTopicsChanged();
	}
	
	public Topic[] getSelectedTopic() {		
		return _selectedTopics.size() == 0? null: (Topic[]) _selectedTopics.values().toArray(new Topic[0]);
	}

	/**
	 * 
	 */
	private void notifySelectedTopicsChanged() {
		this.firePropertyChange("SelectedTopics",null, (Object)getSelectedTopic() );
	}
	/**
	 * @param string
	 * @param topics
	 */
	
	public static void main(String[] args) {
		JFrame frame = new JFrame();
		frame.setSize(500, 500);

		Facet facet = new Facet("Facet 1");
		Topic tp1 = facet.createTopic("aaa");
		Topic tp2 = facet.createTopic("bbb");
		Topic tp3 = facet.createTopic("ccc");
		Topic tp4 = facet.createTopic("ddd");
		tp1.addChild(tp2);
		tp2.addChild(tp3);

		FacetClassifier classfier = new FacetClassifier("Fa");
		classfier.addFacet(facet);
		FacetCollectionPanel panel = new FacetCollectionPanel();
		panel.setFacetClassifier(classfier);
		panel.addPropertyChangeListener("SelectedTopics",new PropertyChangeListener() {

			public void propertyChange(PropertyChangeEvent evt) {
				System.out.println("Property changed:");
				Topic[] topics = (Topic[] )evt.getNewValue();
				if (topics == null){
					System.out.println("None");
					return;
				}
				
				for(int i=0; i < topics.length;i++){
					System.out.println("   "+topics[i].getName());
				}
				
			}});

		frame.getContentPane().add(panel, "Center");
		frame.addWindowListener(new WindowListener() {

			public void windowActivated(WindowEvent e) {
				
			}

			public void windowClosed(WindowEvent e) {
				
			}

			public void windowClosing(WindowEvent e) {
				System.exit(-1);
				
			}

			public void windowDeactivated(WindowEvent e) {
				
			}

			public void windowDeiconified(WindowEvent e) {
				
			}

			public void windowIconified(WindowEvent e) {
				
			}

			public void windowOpened(WindowEvent e) {
				
			}});
		frame.setVisible(true);

	}

} //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
