/*
 * Created on 2004. 3. 3
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package net.narusas.facet.ui;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

import net.narusas.facet.Facet;
import net.narusas.facet.Topic;

/**
 * @author jsahn
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class FacetTree extends JPanel implements Observer {

	private javax.swing.JLabel facetNameLabel = null;
	private javax.swing.JScrollPane jScrollPane = null;
	private javax.swing.JTree jTree = null;

	private Facet facet;
	private Topic selectedTopic;

	/**
	 * This is the default constructor
	 */
	public FacetTree() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new java.awt.BorderLayout());
		this.add(getFacetNameLabel(), java.awt.BorderLayout.NORTH);
		this.add(getJScrollPane(), java.awt.BorderLayout.CENTER);
		this.setSize(192, 133);
	}
	/* (non-Javadoc)
	 * @see java.util.Observer#update(java.util.Observable, java.lang.Object)
	 */
	public void update(Observable arg0, Object arg1) {
		updateModel();
	}
	/**
	 * This method initializes facetNameLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getFacetNameLabel() {
		if (facetNameLabel == null) {
			facetNameLabel = new javax.swing.JLabel();
			facetNameLabel.setText("JLabel");
		}
		return facetNameLabel;
	}
	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new javax.swing.JScrollPane();
			jScrollPane.setViewportView(getJTree());
		}
		return jScrollPane;
	}
	/**
	 * This method initializes jTree
	 * 
	 * @return javax.swing.JTree
	 */
	private javax.swing.JTree getJTree() {
		if (jTree == null) {
			jTree = new javax.swing.JTree();
			jTree
				.addTreeSelectionListener(
					new javax.swing.event.TreeSelectionListener() {
				public void valueChanged(javax.swing.event.TreeSelectionEvent e) {
					treeValueChanged(e);
				}
			});
		}
		return jTree;
	}
	/**
	 * @return
	 */
	public Facet getFacet() {
		return facet;
	}

	/**
	 * @param facet
	 */
	public void setFacet(Facet facet) {
		this.facet = facet;
		updateModel();
	}
	/**
	 * 
	 */
	private void updateModel() {
		facetNameLabel.setText(facet.getName());
		DefaultMutableTreeNode top = new DefaultMutableTreeNode(facet);
		addRecursive(top, facet.getRootTopic());
		DefaultTreeModel model = new DefaultTreeModel(top);
		jTree.setModel(model);
	}
	/**
	 * @param top
	 * @param topics
	 */
	private void addRecursive(DefaultMutableTreeNode parent, Topic[] topics) {
		for (int i = 0; i < topics.length; i++) {
			DefaultMutableTreeNode node = new DefaultMutableTreeNode(topics[i]);
			parent.add(node);
			if (topics[i].getChilds() != null) {
				addRecursive(node, topics[i].getChilds());
			}
		}
	}

	public static void main(String[] args) {
		JFrame frame = new JFrame();
		frame.setSize(500, 500);
		Facet facet = new Facet("Facet 1");
		Topic tp1 = facet.createTopic("aaa");
		Topic tp2 = facet.createTopic("bbb");
		Topic tp3 = facet.createTopic("ccc");
		Topic tp4 = facet.createTopic("ddd");

		tp1.addChild(tp2);
		tp2.addChild(tp3);

		FacetTree tree = new FacetTree();
		tree.addPropertyChangeListener(new PropertyChangeListener() {

			public void propertyChange(PropertyChangeEvent event) {
				Object oldValue = event.getOldValue();
				Object newValue = event.getNewValue();
				System.out.println("Old:" + oldValue + " New:" + newValue);

			}
		});
		tree.setFacet(facet);
		frame.getContentPane().add(tree, "Center");
		frame.setVisible(true);

	}
	/* (non-Javadoc)
	 * @see javax.swing.event.TreeSelectionListener#valueChanged(javax.swing.event.TreeSelectionEvent)
	 */
	public void treeValueChanged(TreeSelectionEvent event) {
		Object old = selectedTopic;

		Object[] objs = jTree.getSelectionPath().getPath();
		DefaultMutableTreeNode node =
			(DefaultMutableTreeNode) objs[objs.length - 1];
		Object source = node.getUserObject();

		if (source instanceof Facet) {
			selectedTopic = null;
			firePropertyChange("SelectedTopic", old, selectedTopic);
		} else if (source instanceof Topic) {
			selectedTopic = (Topic) source;
			firePropertyChange("SelectedTopic", old, selectedTopic);
		}

	}

	/**
	 * @return
	 */
	public Topic getSelectedTopic() {
		return selectedTopic;
	}

} //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
