/*
 * ۼ ¥: 2004. 3. 4.
 *
 */
package net.narusas.facet.ui;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.LayoutManager;
import java.awt.Rectangle;

/**
 * @author JiSung, Ahn
 *
 */
public class HorizontalLayout implements LayoutManager {

	private int _hGap = 5;
	/**
	 * 
	 */
	public HorizontalLayout() {
		super();
	}
	/* (Javadoc)
	 * @see java.awt.LayoutManager#addLayoutComponent(java.lang.String, java.awt.Component)
	 */
	public void addLayoutComponent(String name, Component comp) {

	}

	/* (Javadoc)
	 * @see java.awt.LayoutManager#removeLayoutComponent(java.awt.Component)
	 */
	public void removeLayoutComponent(Component comp) {

	}

	/* (Javadoc)
	 * @see java.awt.LayoutManager#layoutContainer(java.awt.Container)
	 */
	public void layoutContainer(Container parent) {
		Rectangle parentBound = parent.getBounds();

		Insets insets = parent.getInsets();
		int w = 0;
		int h = parent.getHeight();
		int x = insets.left;
		int y = insets.top;

		for (int i = 0; i < parent.getComponentCount(); i++) {
			Component comp = parent.getComponent(i);
			Dimension d = comp.getPreferredSize();
			comp.setBounds(x, y, d.width, h);
			x += d.width + _hGap;
		}

	}

	/* (Javadoc)
	 * @see java.awt.LayoutManager#minimumLayoutSize(java.awt.Container)
	 */
	public Dimension minimumLayoutSize(Container parent) {
		
		return preferredLayoutSize(parent);
	}

	/* (Javadoc)
	 * @see java.awt.LayoutManager#preferredLayoutSize(java.awt.Container)
	 */
	public Dimension preferredLayoutSize(Container parent) {
		
		int w = 0;
		int h = parent.getParent().getHeight();
		for (int i = 0; i < parent.getComponentCount(); i++) {
			Component comp = parent.getComponent(i);
			Dimension d = comp.getPreferredSize();
			w += d.width + _hGap;
		}
		w -= _hGap;
		Insets insets = parent.getInsets();

		return new Dimension(
			w + insets.left + insets.right,
			h + insets.top + insets.bottom);
	}

	/**
	 * @return
	 */
	public int getHGap() {
		return _hGap;
	}

	/**
	 * @param i
	 */
	public void setHGap(int i) {
		_hGap = i;
	}

}
