/*
 * ۼ ¥: 2004. 3. 5.
 *
 */
package net.narusas.facet.ui;

import java.awt.HeadlessException;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;

import javax.swing.JFrame;

import net.narusas.facet.Facet;
import net.narusas.facet.Resource;
import net.narusas.facet.Topic;
import net.narusas.facet.file.FileFacetClassifier;

/**
 * @author Administrator
 *
 */
public class Prototype2 extends JFrame {

	private FileFacetClassifier _classifier;

	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JSplitPane jSplitPane = null;
	private FacetCollectionPanel topPanel = null;
	private ResourceTable bottomPanel = null;

	/**
	 * @throws java.awt.HeadlessException
	 */
	public Prototype2() throws HeadlessException {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		_classifier = new FileFacetClassifier("Sample");

		_classifier.addFile(new File("C:\\4DUPnP01.jpg"));
		_classifier.addFile(new File("C:\\4DUPnP02.jpg"));
		_classifier.addFile(new File("C:\\Ϻ.hwp"));

		
		Facet nameFacet = new Facet("Name", "Name");		
		Facet locationFacet = new Facet("file.location", "Location");
		Facet extFacet = _classifier.getFacets()[0];
		

		getResourceTable().setResources(_classifier.getAllResources());
		getResourceTable().setFacets(new Facet[] { nameFacet, extFacet, locationFacet });

		getFacetCollectionPanel().setFacetClassifier(_classifier);
		getFacetCollectionPanel()
			.addPropertyChangeListener(
				"SelectedTopics",
				new PropertyChangeListener() {

			public void propertyChange(PropertyChangeEvent evt) {
				System.out.println("Property changed:");
				Topic[] topics = (Topic[]) evt.getNewValue();

				if (topics == null) {
					System.out.println("  None");
					getResourceTable().setResources(
						_classifier.getAllResources());
					return;
				}
				for (int i = 0; i < topics.length; i++) {
					System.out.println(" T:" + topics[i]);
				}

				Resource[] res = _classifier.match(topics);
				if (res != null) {
					for (int i = 0; i < res.length; i++) {
						System.out.println(" R:" + res[i].getId());
					}
				}
				getResourceTable().setResources(res);
				getResourceTable().setTopics(topics);

			}
		});

		this.setSize(478, 412);
		this.setContentPane(getJContentPane());
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.add(getJSplitPane(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jSplitPane
	 * 
	 * @return javax.swing.JSplitPane
	 */
	private javax.swing.JSplitPane getJSplitPane() {
		if (jSplitPane == null) {
			jSplitPane = new javax.swing.JSplitPane();
			jSplitPane.setTopComponent(getFacetCollectionPanel());
			jSplitPane.setBottomComponent(getResourceTable());
			jSplitPane.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
			jSplitPane.setDividerLocation(130);
		}
		return jSplitPane;
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private FacetCollectionPanel getFacetCollectionPanel() {
		if (topPanel == null) {
			topPanel = new FacetCollectionPanel();
		}
		return topPanel;
	}
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private ResourceTable getResourceTable() {
		if (bottomPanel == null) {
			bottomPanel = new ResourceTable();
		}
		return bottomPanel;
	}

	public static void main(String[] args) {
		Prototype2 frame = new Prototype2();
		frame.setSize(500, 500);

		frame.addWindowListener(new WindowListener() {

			public void windowActivated(WindowEvent e) {

			}

			public void windowClosed(WindowEvent e) {

			}

			public void windowClosing(WindowEvent e) {
				System.exit(-1);

			}

			public void windowDeactivated(WindowEvent e) {

			}

			public void windowDeiconified(WindowEvent e) {

			}

			public void windowIconified(WindowEvent e) {

			}

			public void windowOpened(WindowEvent e) {

			}
		});
		frame.setVisible(true);

	}
} //  @jve:visual-info  decl-index=0 visual-constraint="10,9"
